//Copyright 1999-2002 Gavin Conant

#ifndef ___READ_SEQ_H___
#define ___READ_SEQ_H___

#include <fstream.h>
#include "gen_dna_funcs.h"



struct sequence {
  int site;
  sequence *next_site;
};


BOOL test_interleave(char *filename);


class Read_Sequence 
{
 public:
  //Functions
  Read_Sequence();
  virtual Sequence_dataset * get_dataset(int &num_taxa, int &num_sites, 
				char *filename, BOOL is_aa_seq)=0;
  int get_num_taxa();
  int get_num_chars();
  BOOL protein_data();
  ~Read_Sequence();

 protected:
  int size, ntaxa;
  char last_char;
  ifstream infile;
  BOOL aa_data;
  sequence *in_seq, *in_seq_start, *temp;
  List_Molecule_Sequence *build_taxa, *taxa_start, *temp_taxa;
  int (*convert_char)(char);
  BOOL(*valid_input)(char);

  //Functions
  void get_sequence_array_size_known(Molecule_Sequence *new_sequence);
  void get_sequence_array(Molecule_Sequence *&new_sequence);
  void set_datatype(DATATYPE cdata);
  void get_next_list_element(List_Molecule_Sequence *&thelist);
  void get_next_sequence_element(sequence *&thelist);
};



class Read_PIR : public Read_Sequence 
{
 public:
  Sequence_dataset * get_dataset(int &num_taxa, int &num_sites, 
			char *filename, BOOL is_aa_seq);
};



class Read_Nexus : public Read_Sequence 
{
 public:
  Sequence_dataset * get_dataset(int &num_taxa, int &num_sites, 
			char *filename, BOOL is_aa_seq);
};



class Read_Phylip_interleave : public Read_Sequence 
{
 public:
  Sequence_dataset * get_dataset(int &num_taxa, int &num_sites, 
			char *filename, BOOL is_aa_seq);

};



class Read_Phylip_noninterleave : public Read_Sequence 
{
 public:
  Sequence_dataset * get_dataset(int &num_taxa, int &num_sites, 
				 char *filename, BOOL is_aa_seq);

};




class Read_FASTA : public Read_Sequence
{

 public:
  Sequence_dataset * get_dataset(int &num_taxa, int &num_sites, 
		   char *filename, BOOL is_aa_seq);

};


#endif




